﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

namespace Rozdział_36
{
    class Program
    {
        static void Main(string[] args)
        {
            //IteratorDrillDown();
            //IteratorWithoutInterfaces();
            CSharp20Iterators();

            Console.ReadKey();
        }

        private static void CSharp20Iterators()
        {
            var hospStaff = new HospitalStaffWithIterators
            {
                Doctor = "Marcus",
                Nurse = "Nancy",
                Intern1 = "Dmitri",
                Intern2 = "Helga"
            };

            foreach (var name in hospStaff)
            {
                Console.WriteLine(name);
            }
        }

        private static void IteratorWithoutInterfaces()
        {
            var hospStaff = new HospitalStaffWithoutIEnumerator
            {
                Doctor = "Marcus",
                Nurse = "Nancy",
                Intern1 = "Dmitri",
                Intern2 = "Helga"
            };

            foreach (var name in hospStaff)
            {
                Console.WriteLine(name);
            }
        }

        private static void IteratorDrillDown()
        {
            var hospStaff = new HospitalStaff
            {
                Doctor = "Marcus",
                Nurse = "Nancy",
                Intern1 = "Dmitri",
                Intern2 = "Helga"
            };

            if (hospStaff is IEnumerable<string>)
            {
                IEnumerator<string> hospStaffEnumerator = hospStaff.GetEnumerator();
                string name;
                hospStaffEnumerator.Reset();

                while (hospStaffEnumerator.MoveNext())
                {
                    name = hospStaffEnumerator.Current;

                    Console.WriteLine(name);
                }
            }

            foreach (var name in hospStaff)
            {
                Console.WriteLine(name);
            }
        }
    }
}
